SystemOrganization addCategory: #VisibilityProfiler!
SystemOrganization addCategory: #'VisibilityProfiler-SampleTests'!
SystemOrganization addCategory: #'VisibilityProfiler-Ruby'!

TestCase subclass: #SimpleTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-SampleTests'!

!SimpleTests methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 18:09'!
testRubyProfiler
	VPSimpleTestA new method1.
	self assert: true.! !

MethodSpy subclass: #VisibilityProfilerMethod
	instanceVariableNames: 'callerMethods isCovered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerMethod methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 15:31'!
beforeRun: methodName with: listOfArguments in: receiver
	isCovered:=true.
	callerMethods add:(self callingMethod).
	! !

!VisibilityProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/30/2012 19:47'!
callerMethods
	^callerMethods.! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/5/2012 20:09'!
findNumberOfExternalCallerMethods
	^ callerMethods inject: 0 into: [ :result :m | ( (m methodClass == self theClass) |( self theClass allSubclasses includes: (m methodClass) ) )ifTrue:[result+0] ifFalse: [result+1].]! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/5/2012 20:09'!
getInternalCallerMethods
	"This method gets all the methods that calls this methods from its own class (or are in the hierarchy)."
	^ callerMethods inject: OrderedCollection new into: [ :result :m | ( (m methodClass == self theClass) or:( self theClass allSubclasses includes: (m methodClass) ) )ifTrue:[result add:m; yourself ] ifFalse: [result].]! !

!VisibilityProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 15:30'!
initialize
	super initialize.
	callerMethods:=IdentitySet new.
	isCovered:=false.! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/2/2012 13:24'!
isABadEncapsulationCandidateWitZeroOrMoreInterMethods: aTotalNumberOfInterMethods
	0 to:aTotalNumberOfInterMethods do:[:aNumberOfMethods|
		(self isABadEncapsulationCandidateWithInterMethods: aNumberOfMethods) ifTrue: [^true].
	].
	^false.! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/2/2012 17:25'!
isABadEncapsulationCandidateWithInterMethods: aNumberOfInterMethods
	"It is a candidate if it is a public method that is called for a few external methods and at least an inner method that has more external methods as caller"
	|externalCallerMethodThreshold externalCallerMethodFactorThreshold|
	externalCallerMethodThreshold:=self profiler externalCallerMethodThreshold.
	externalCallerMethodFactorThreshold:=self profiler externalCallerMethodFactorThreshold.
	self isPublic ifTrue: [
		|numberOfexternalCallerMethods|
		numberOfexternalCallerMethods:=self findNumberOfExternalCallerMethods.
		(numberOfexternalCallerMethods <externalCallerMethodThreshold) ifTrue: [
			|internalCallerMethods interMethodsRemaining|
			
			internalCallerMethods:=self getInternalCallerMethods.
			interMethodsRemaining:=aNumberOfInterMethods.
			[interMethodsRemaining>0]whileTrue: [
				|notPubicMethods filterNotPublicMethods|
				"Filtro solo los metodos que no sean publicos"
				notPubicMethods:=OrderedCollection new.
				filterNotPublicMethods:=false.
				
				internalCallerMethods do:[:anInternalCaller|
					|spyMethod|
					spyMethod:=(self spyMethod:anInternalCaller).
					(spyMethod==nil)ifFalse: [
					filterNotPublicMethods ifFalse: [notPubicMethods add: spyMethod.]
					ifTrue: [
						spyMethod isPublic ifFalse: [
							notPubicMethods add: spyMethod.
						].
					]].
				].
				
				"Cambio el internalCallerMethods por todos los metodos internos que llamaban a los notPublic"
				internalCallerMethods:=OrderedCollection new.
				notPubicMethods do:[:aNotPublicMethod|
					internalCallerMethods addAll: aNotPublicMethod getInternalCallerMethods.
				].
				interMethodsRemaining:=interMethodsRemaining-1.
			].
			
			(internalCallerMethods size >0)ifTrue: [
					internalCallerMethods do:[:anInternalCaller|
						|internalCallerSpyMethod|
						internalCallerSpyMethod:=(self spyMethod:anInternalCaller).
						(internalCallerSpyMethod ==nil) ifFalse:[
						(internalCallerSpyMethod findNumberOfExternalCallerMethods >(numberOfexternalCallerMethods*externalCallerMethodFactorThreshold)) ifTrue: [^true].]
					].
			].
		].
	].
	^false.! !

!VisibilityProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 15:31'!
isCovered 
	^isCovered.! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/4/2012 19:28'!
isOnlyCalledByTests
	"(self isPrivate | self isProtected | self isPackaged)ifTrue: [^false]."
	
	^ callerMethods inject: true into: [ :result :m |  result and: [ (m methodClass=TestCase) or: [m methodClass inheritsFrom:TestCase]]]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/4/2012 19:05'!
isPackaged
	(self isPrivate | self isProtected | self isOnlyCalledByTests)ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  result and: [ (m methodClass == self theClass) or: [self methodsInSameCategoryThanMe:m ]] ]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/4/2012 19:29'!
isPackagedWithTests
	(self isPrivate | self isProtected | self isPackaged | self isPrivateWithTests | self isProtectedWithTests | self isOnlyCalledByTests)ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  result and: [ (m methodClass == self theClass) or:[(self methodsInSameCategoryThanMe:m) or:[(m methodClass=TestCase) or: [m methodClass inheritsFrom:TestCase]]]]]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/5/2012 20:53'!
isPrivate
	"A method is private if it is called only by methods of its own class or if it is not called for any method"
	(self isOnlyCalledByTests)ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  result and: [ m methodClass == self theClass or:[self methodIsDefinedInAFather: m] "o el callerClass es un padre de esta clase y el metodo esta definido ahi y no en esta clase"]]
	! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/4/2012 19:29'!
isPrivateWithTests
	(self isPrivate | self isProtected | self isPackaged | self isOnlyCalledByTests)ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  result and: [ (m methodClass == self theClass) or:[(m methodClass=TestCase) or: [m methodClass inheritsFrom:TestCase]]]]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/5/2012 20:19'!
isProtected
	(self isPrivate|self isOnlyCalledByTests) ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  result and: [ (m methodClass == self theClass) or: [ (self theClass allSubclasses includes: (m methodClass)) or:[(self theClass allSuperclasses includes: (m methodClass))]   ]] ]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/5/2012 20:13'!
isProtectedWithTests
	(self isPrivate | self isProtected | self isPackaged | self isPrivateWithTests | self isOnlyCalledByTests)ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  result and: [ (m methodClass == self theClass) or:[(self theClass allSubclasses includes: (m methodClass)) or:[(m methodClass=TestCase) or: [m methodClass inheritsFrom:TestCase]]]]]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/4/2012 17:50'!
isPublic
	self isPrivate ifTrue: [^false].
	self isProtected ifTrue: [^false].
	self isPackaged ifTrue: [^false].
	self isPrivateWithTests ifTrue: [^false].
	self isProtectedWithTests ifTrue: [^false].
	self isPackagedWithTests ifTrue: [^false].
	self isOnlyCalledByTests ifTrue: [^false].
	^true.! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/5/2012 21:44'!
methodIsDefinedInAFather: aCallingMethod
	"el callerClass es un padre de esta clase y el metodo esta definido ahi y no en esta clase"
	
	"(self theClass allSuperclasses includes: (aCallingMethod methodClass)) ifTrue: [
		(aCallingMethod isSubclassResponsibility) ifTrue: [^false].
		(aCallingMethod methodClass) methods do:[:aMethod|
			(aMethod selector asString =self selector asString)ifTrue: [
				
				(aMethod isSubclassResponsibility) ifTrue: [^false]
				ifFalse:[""Si llegue hasta aca es porque estoy sobreescribiendo (SOLO EN EL CASO DE QUE el metodo no este implementado en la clase). Entonces es protected""self halt]."
				"Si es un overwritting method devuelvo false"
		"	].
		]
		
	]."
	^false.! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/3/2012 17:38'!
methodsInSameCategoryThanMe: aCompiledMethod
	|category| 
	(aCompiledMethod methodClass isMeta)ifTrue: [
		category:= aCompiledMethod methodClass soleInstance category] 
	ifFalse: [category:= aCompiledMethod methodClass  category]. 
	^category==(self theClass category)! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/1/2012 11:52'!
spyMethod: aCompileMethod

	self profiler allMethods do:[:anSpyMethod|
		
	((aCompileMethod methodClass == anSpyMethod theClass) &(aCompileMethod selector ==anSpyMethod selector))ifTrue: [^anSpyMethod].
	].
	^nil.
	"el metodo spy que consiga compiledMethod==aCompileMethod"! !

MethodSpy subclass: #VisibilityRubyProfilerMethod
	instanceVariableNames: 'currentState isCovered callerObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-Ruby'!

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 12:35'!
privateState
	^'private'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 12:36'!
privateWithTestsState
	^'privateWithTests'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 12:35'!
protectedState
	^'protected'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 16:48'!
protectedWithTestsState
	^'protectedWithTests'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 12:36'!
publicState
	^'public'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 12:33'!
undefinedState
	^'undefined'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 16:49'!
undefinedTestState
	^'undefinedTest'! !

!VisibilityRubyProfilerMethod methodsFor: 'hooks' stamp: 'SantiagoVidal 5/5/2012 19:26'!
beforeRun: methodName with: listOfArguments in: receiver
	| callingObject callingClass "co1 co2"|
	isCovered:=true.
	callingClass:=self callingMethod methodClass.
	"co1:=thisContext sender sender receiver.
	co2 := thisContext sender sender sender sender receiver."
	callingObject := thisContext sender sender sender receiver."self callingMethod methodClass."
	callerObjects add:callingClass.
	
	"(self classSpy className asString ='RODecorator' and:[methodName='addLast:in:']) ifTrue: [self halt.]."
	(self isPublic) ifFalse: [
		(self isUndefinedTest) ifTrue: [
			
			(self senderIsATestClass:callingClass) ifFalse: [
				(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifTrue: [
					(receiver == callingObject) ifFalse: [currentState:=VisibilityRubyProfilerMethod protectedWithTestsState.]
						ifTrue: [currentState:=VisibilityRubyProfilerMethod privateWithTestsState.].	
				] ifFalse: [currentState:=VisibilityRubyProfilerMethod publicState.].
			]
		] ifFalse: [
			(self isProtected) ifTrue: [
				(self senderIsATestClass:callingClass) ifTrue: [
					currentState:=VisibilityRubyProfilerMethod protectedWithTestsState.
				] ifFalse: [
					(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifFalse: [ 						
						currentState:=VisibilityRubyProfilerMethod publicState.
					]
				].	
			] ifFalse: [
				(self isProtectedWithTests) ifTrue: [
					(self senderIsATestClass:callingClass) ifFalse: [
						(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifFalse: [
							currentState:=VisibilityRubyProfilerMethod publicState.
						]
					]
				] ifFalse: [
					(self isPrivate) ifTrue: [
						(self senderIsATestClass:callingClass) ifTrue: [ 
							currentState:=VisibilityRubyProfilerMethod privateWithTestsState.
						] ifFalse: [
							(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifTrue: [
								(receiver == callingObject) ifFalse: [currentState:=VisibilityRubyProfilerMethod protectedState]
							] ifFalse: [currentState:=VisibilityRubyProfilerMethod publicState.].
						].
					] ifFalse: [
						(self isPrivateWithTests) ifTrue: [
							(self senderIsATestClass:callingClass) ifFalse: [
								(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifTrue: [
									(receiver == callingObject) ifFalse: [currentState:=VisibilityRubyProfilerMethod protectedWithTestsState.]
								] ifFalse: [currentState:=VisibilityRubyProfilerMethod publicState.].
							]
						] ifFalse: [
							(self isUndefined) ifTrue: [
								(self senderIsATestClass:callingClass) ifTrue: [
									
									currentState:=VisibilityRubyProfilerMethod undefinedTestState.
								] ifFalse: [
									(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifTrue: [
										(receiver == callingObject) ifFalse: [currentState:=VisibilityRubyProfilerMethod protectedState.]
											ifTrue: [currentState:=VisibilityRubyProfilerMethod privateState].	
									] ifFalse: [currentState:=VisibilityRubyProfilerMethod publicState.].
								]
							] ifFalse: [
								self halt. "ERROR"
							]
						]
					]
				]
			]
		]
	]
	! !

!VisibilityRubyProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 19:20'!
callerObjects
	^callerObjects.! !

!VisibilityRubyProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 19:13'!
initialize 
	super initialize.
	currentState:=VisibilityRubyProfilerMethod undefinedState.
	isCovered:=false.
	callerObjects:=OrderedCollection new.! !

!VisibilityRubyProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 15:32'!
isCovered
	^isCovered.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 12:36'!
isPrivate
	^currentState =VisibilityRubyProfilerMethod privateState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 12:37'!
isPrivateWithTests 
	^currentState =VisibilityRubyProfilerMethod privateWithTestsState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 12:37'!
isProtected
	^currentState =VisibilityRubyProfilerMethod protectedState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 16:49'!
isProtectedWithTests 
	^currentState =VisibilityRubyProfilerMethod protectedWithTestsState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 12:37'!
isPublic 
	^currentState =VisibilityRubyProfilerMethod publicState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 12:35'!
isUndefined
	^currentState =VisibilityRubyProfilerMethod undefinedState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 16:50'!
isUndefinedTest
	^currentState =VisibilityRubyProfilerMethod undefinedTestState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/5/2012 20:14'!
senderAndReceiverAreRelated: callingObject theReceiver:receiver
	"This methods checks if the caller and the receiver belongs to the same class or if the caller belongs to a subclass of the receiver"
	(receiver == callingObject)ifTrue:[^true].
	(callingObject class == self theClass) ifTrue:[^true].
	^(self theClass allSubclasses includes: (callingObject class))
	! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 19:26'!
senderIsATestClass:callingObject
	(callingObject=TestCase) ifTrue: [^true].
	^callingObject  inheritsFrom:TestCase.! !

AbstractSpyTest subclass: #VisibilityProfilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerTest methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
profilerClass
	^  VisibilityProfiler! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 09:43'!
testPrivateMethod
	|methods|
	methods:=self runScenario allMethods.
	
	"Private method with 3 callers <TGFoo>>foo1>"
	self assert: (methods at:66) isPrivate.
	
	"Private method with 2 callers <TGFoo>>foo3>"
	self assert: (methods at:61) isPrivate.
	
	"Private method with 0 callers <TGFooSubClass2>>indirectSideEffect:>"
	self assert: (methods at:2) isPrivate.
	
	! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 17:06'!
testPrivateWithTestsMethod
	|methods|
	methods:=self runScenario allMethods.
	
	"<TGCar>>addWheel:> called for tests and classes"
	self assert: (methods at:15) isPrivateWithTests.
	"<TGCar>>driver:> called only for tests"
	self assert: (methods at:16) isPrivateWithTests.
	! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 09:55'!
testProtectedMethod
	|methods|
	methods:=self runScenario allMethods.
	
	"There is not a scenario with a protectred method"
	"Private method with 2 callers <TGFoo>>initialize>"
	
	"self assert: (methods at:59) isProtected."
	
! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 17:05'!
testPublicMethod
	|methods|
	methods:=self runScenario allMethods.
	
	
	"<TGCar>>hash> called only for classes but one of them is a false dependency"
	self assert: (methods at:11) isPublic.
	"<TGCar>>giveMeANewCarForDriver:> called only for classes"
	self assert: (methods at:13) isPublic.! !

AbstractSpyTest subclass: #VisibilityRubyProfilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-Ruby'!

!VisibilityRubyProfilerTest methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 11:16'!
profilerClass
	^  VisibilityRubyProfiler! !

!VisibilityRubyProfilerTest methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 18:26'!
testRubyVisibilities
	|profiler methods problemsDetected|
	profiler:=VisibilityRubyProfiler runTestsForClassCategory: 'VisibilityProfiler-SampleTests'.
	methods:=profiler allMethods select: [:am| am isCovered].
	Transcript show: 'numberOfMethods: ', methods size asString;cr.
Transcript show: 'Private Methods: ', (methods inject:0 into:[:count :am| 
	(am isPrivate)ifTrue: [count+1] ifFalse: [count]]) asString;cr.
Transcript show: 'Protected Methods: ', (methods inject:0 into:[:count :am| 
	(am isProtected)ifTrue: [count+1] ifFalse: [count]]) asString;cr.
Transcript show: 'PrivateWithTests Methods: ', (methods inject:0 into:[:count :am| 
	(am isPrivateWithTests)ifTrue: [count+1] ifFalse: [count]]) asString;cr.
Transcript show: 'ProtectedWithTests Methods: ', (methods inject:0 into:[:count :am| 
	(am isProtectedWithTests)ifTrue: [count+1] ifFalse: [count]]) asString;cr.
Transcript show: 'UndefinedTests Methods: ', (methods inject:0 into:[:count :am| 
	(am isUndefinedTest)ifTrue: [count+1] ifFalse: [count]]) asString;cr.
Transcript show: 'Public Methods: ', (methods inject:0 into:[:count :am| 
	(am isPublic)ifTrue: [count+1] ifFalse: [count]]) asString;cr.! !

PackageSpy subclass: #VisibilityProfilerPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerPackage class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForClass
	 ^ VisibilityProfilerClass! !

PackageSpy subclass: #VisibilityRubyProfilerPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-Ruby'!

!VisibilityRubyProfilerPackage class methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 11:16'!
spyClassForClass
	 ^ VisibilityRubyProfilerClass! !

ClassSpy subclass: #VisibilityProfilerClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerClass class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForMethod
	 ^ VisibilityProfilerMethod! !

ClassSpy subclass: #VisibilityRubyProfilerClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-Ruby'!

!VisibilityRubyProfilerClass class methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 11:16'!
spyClassForMethod
	 ^ VisibilityRubyProfilerMethod! !

Profiler subclass: #VisibilityProfiler
	instanceVariableNames: 'externalCallerMethodThreshold externalCallerMethodFactorThreshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfiler class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForPackage
	 ^ VisibilityProfilerPackage! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:52'!
externalCallerMethodFactorThreshold
	 ^externalCallerMethodFactorThreshold! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:52'!
externalCallerMethodFactorThreshold:aNumber
	externalCallerMethodFactorThreshold:=aNumber.! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:50'!
externalCallerMethodThreshold
	^externalCallerMethodThreshold.! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:49'!
externalCallerMethodThreshold: aNumber
	externalCallerMethodThreshold:=aNumber.! !

!VisibilityProfiler methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/2/2012 12:40'!
initialize
	externalCallerMethodThreshold:=4.
	externalCallerMethodFactorThreshold:=2.! !

!VisibilityProfiler methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
registryName
	^ #VisibilityProfiler! !

!VisibilityProfiler methodsFor: 'visualization' stamp: 'SantiagoVidal 5/4/2012 15:38'!
visualizeOn: view
	view nodes: self allClasses forEach: [ :each | 
		view shape rectangle borderColor:  [:m | m isCovered ifFalse: [Color yellow] ifTrue: [m isPrivate ifTrue: [ Color black ] ifFalse: [ m isProtected ifTrue: [Color orange] ifFalse: [m isPackaged ifTrue:[Color blue] ifFalse:[m isPrivateWithTests ifTrue: [Color lightGray] ifFalse:[(m isABadEncapsulationCandidateWitZeroOrMoreInterMethods:5) ifTrue: [Color red] ifFalse: [Color green]]] ]]]].
		view nodes: each methods.
		view gridLayout gapSize: 2.
	].
	view edgesFrom: #superclass.
	view treeLayout
	! !

Profiler subclass: #VisibilityRubyProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-Ruby'!

!VisibilityRubyProfiler class methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 11:16'!
spyClassForPackage
	 ^ VisibilityRubyProfilerPackage! !

!VisibilityRubyProfiler methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 11:16'!
registryName
	^ #VisibilityRubyProfiler! !

!VisibilityRubyProfiler methodsFor: 'visualization' stamp: 'SantiagoVidal 5/4/2012 11:16'!
visualizeOn: view
	view nodes: self allClasses forEach: [ :each | 
		view nodes: each methods.
		view gridLayout gapSize: 2.
	].
	view edgesFrom: #superclass.
	view treeLayout
	! !

Object subclass: #CaseStudies
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!CaseStudies methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/2/2012 16:48'!
createAreaChartData
|profiler methods|
profiler:=VisibilityProfiler runTestsForPackagesMatching: 'Mondrian*'.
methods:=profiler allMethods.
2 to: 20 do:[:externalCallerMethodThreshold|
	|externalCallerMethodFactorThreshold|
	externalCallerMethodFactorThreshold:=1.
	[externalCallerMethodFactorThreshold<=3.1] whileTrue: [
		|problemsDetected|
		"Transcript show: externalCallerMethodThreshold asString, ' ', externalCallerMethodFactorThreshold asString; cr."
		profiler externalCallerMethodThreshold:externalCallerMethodThreshold.
		profiler externalCallerMethodFactorThreshold:externalCallerMethodFactorThreshold.
		problemsDetected:=methods inject:0 into:[:count :am| (am isABadEncapsulationCandidateWitZeroOrMoreInterMethods:5)ifTrue: [count+1] ifFalse: [count]].
		Transcript show: problemsDetected asString, String tab.
		externalCallerMethodFactorThreshold:=externalCallerMethodFactorThreshold+0.1.
	].
	Transcript show: String cr.
].! !

Object subclass: #TestProfilers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-SampleTests'!

!TestProfilers methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/6/2012 16:00'!
calculateAverageOf: aNumberOfMethods for: totalNumberOfMethods
	^((aNumberOfMethods*100)/totalNumberOfMethods)! !

!TestProfilers methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/5/2012 18:31'!
compareProfilersResults
	|javaProfiler rubyProfiler methodsJava methodsRuby differences|
	javaProfiler:=VisibilityProfiler runTestsForPackagesMatching: 'Roassal*'.
	methodsJava:=(javaProfiler allMethods select: [:am| am isCovered]) select: [:am|am isPrivate].
	rubyProfiler:=VisibilityRubyProfiler runTestsForPackagesMatching: 'Roassal*'.
	methodsRuby:=(rubyProfiler allMethods select: [:am| am isCovered]) select: [:am|am isPrivate].
	differences:=self findExtraMethodsIn: methodsJava regarding: methodsRuby.
	
	differences do:[:aPrivateMethod|
		(rubyProfiler allMethods select: [:am| am isCovered]) do:[:anSpyMethod2|
			((aPrivateMethod selector asString =anSpyMethod2 selector asString) and:[aPrivateMethod classSpy asString =anSpyMethod2 classSpy asString]) ifTrue: [self halt.].
		].
	].
	
	differences:=self findExtraMethodsIn: methodsRuby regarding: methodsJava.
	differences do:[:aPrivateMethod|
		(javaProfiler allMethods select: [:am| am isCovered]) do:[:anSpyMethod2|
			((aPrivateMethod selector asString =anSpyMethod2 selector asString) and:[aPrivateMethod classSpy asString =anSpyMethod2 classSpy asString]) ifTrue: [self halt.].
		].
	].
	Transcript show:'Ready'.! !

!TestProfilers methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/5/2012 17:55'!
existMethod: aSpyMethod inCollection: aCollectionOfMethods
	aCollectionOfMethods do:[:anSpyMethod2|
		((aSpyMethod selector asString =anSpyMethod2 selector asString) and:[aSpyMethod classSpy asString =anSpyMethod2 classSpy asString]) ifTrue: [^true].
	].
	^false.! !

!TestProfilers methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/5/2012 17:56'!
findExtraMethodsIn: collection1 regarding: collection2
	|ret|
	ret:=OrderedCollection new.
	collection1 do:[:anSpyMethod1|
		(self existMethod: anSpyMethod1 inCollection: collection2) ifFalse: [ret add: anSpyMethod1].
	].
	^ret.! !

!TestProfilers methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/6/2012 16:17'!
formatNumber: aFloat
	|averageForTable|
	averageForTable:=(aFloat asFloat asString).
	averageForTable at: (averageForTable indexOf:$.)  put:$,.
	^averageForTable.! !

!TestProfilers methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/6/2012 16:12'!
printResults: anArrayOfResults
	anArrayOfResults do:[:result|
		Transcript show: result asString,String tab.
	]! !

!TestProfilers methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/6/2012 16:41'!
testJavaProfiler
	|profiler methods problemsDetected results|
profiler:=VisibilityProfiler runTestsForPackagesMatching: 'Regex*'.
methods:=profiler allMethods select: [:am| am isCovered].
	results:=OrderedCollection new.
"methods do:[:am| 
	|count|
	count:=0.
	(am isPrivate)ifTrue: [count:=count+1].
	(am isProtected)ifTrue: [count:=count+1].
	(am isPackaged)ifTrue: [count:=count+1].
	(am isPrivateWithTests)ifTrue: [count:=count+1].
	(am isProtectedWithTests)ifTrue: [count:=count+1].
	(am isPackagedWithTests)ifTrue: [count:=count+1].
	(am isPublic)ifTrue: [count:=count+1].
	(count~~1)ifTrue: [self halt.].
	]."



Transcript show: 'numberOfMethods: ', methods size asString;cr.
Transcript show: 'Private Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isPrivate)ifTrue: [count+1] ifFalse: [count]]) )asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'Protected Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isProtected)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'Package Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isPackaged)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'PrivateWithTests Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isPrivateWithTests)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'ProtectedWithTests Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isProtectedWithTests)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'PackagedWithTests Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isPackagedWithTests)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'OnlyCalledByTests Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isOnlyCalledByTests)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'Public Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isPublic)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).

self printResults: results
"profiler externalCallerMethodThreshold:8.
		profiler externalCallerMethodFactorThreshold:1.
problemsDetected:=methods inject:0 into:[:count :am| 
	(am isABadEncapsulationCandidateWitZeroOrMoreInterMethods:0)ifTrue: [count+1] ifFalse: [count]].

Transcript show: problemsDetected asString, String tab."
"methods do:[:am| Transcript show: am isPackaged asString;cr.]."
"profiler visualize."
"(methods at:2) isPrivate."
"methods do:[:am| Transcript show: am isABadEncapsulationCandidate asString;cr.]."

"profiler visualize."! !

!TestProfilers methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/6/2012 16:42'!
testRubyProfiler
	|profiler methods problemsDetected results|
profiler:=VisibilityRubyProfiler runTestsForPackagesMatching: 'Regex*'.
	results:=OrderedCollection new.
methods:=profiler allMethods select: [:am| am isCovered].
Transcript show: 'numberOfMethods: ', methods size asString;cr.
Transcript show: 'Private Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isPrivate)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'Protected Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isProtected)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'PrivateWithTests Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isPrivateWithTests)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'ProtectedWithTests Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isProtectedWithTests)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'OnlyCalledByTests Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isUndefinedTest)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
Transcript show: 'Public Methods: ', (results add:(methods inject:0 into:[:count :am| 
	(am isPublic)ifTrue: [count+1] ifFalse: [count]])) asString;cr.
results add: (self formatNumber:(self calculateAverageOf: (results last) for: (methods size)) ).
self printResults: results.! !

Object subclass: #VPSimpleTestA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-SampleTests'!

!VPSimpleTestA methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 18:06'!
method1
	self method2.! !

!VPSimpleTestA methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 18:05'!
method2! !

VPSimpleTestA subclass: #VPSimpleTestB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-SampleTests'!
